﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace DragNDropFileIcon
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        #region Drop
        private void DropArea_Drop(object sender, DragEventArgs e)
        {
            if (e.Data.GetDataPresent(DataFormats.FileDrop))
            {
                //DropListBox.Items.Clear();

                string[] droppedFilePaths = e.Data.GetData(DataFormats.FileDrop, true) as string[];

                foreach (string droppedFilePath in droppedFilePaths)
                {


                    ListBoxItem fileItem = new ListBoxItem();

                    fileItem.Content = System.IO.Path.GetFileNameWithoutExtension(droppedFilePath);
                    fileItem.ToolTip = droppedFilePath;

                    //    if (fileItem.DataContextChanged 
                    //    {

                    //    }

                    DropArea.Items.Add(fileItem);


                }
            }
        }
        #endregion

        #region ListBoxSearch
        private void ListBoxSearch(bool sender, RoutedEventArgs e)
        {
            foreach (ListBoxItem li in DropArea.Items)
            {

                ListBoxItem fileItem = new ListBoxItem();

                if (li.ToolTip == fileItem.ToolTip)
                {

                    MessageBox.Show("It exists!");
                    break;
                }


                DropArea.Items.Add(fileItem);

            }
        }
        #endregion

        #region MyFiles
        public class MyFiles
        {
            public string FileName { get; set; }
            public ImageSource FileIcon { get; set; }
        }
        #endregion

        #region FileToImageIconConverter
        public class FileToImageIconConverter
        {
            private string filePath;
            private System.Windows.Media.ImageSource icon;

            public string FilePath { get { return filePath; } }

            public System.Windows.Media.ImageSource Icon
            {
                get
                {
                    if (icon == null && System.IO.File.Exists(FilePath))
                    {
                        using (System.Drawing.Icon sysicon = System.Drawing.Icon.ExtractAssociatedIcon(FilePath))
                        {
                            icon = System.Windows.Interop.Imaging.CreateBitmapSourceFromHIcon(
                                      sysicon.Handle,
                                      System.Windows.Int32Rect.Empty,
                                      System.Windows.Media.Imaging.BitmapSizeOptions.FromEmptyOptions());
                        }
                    }

                    return icon;
                }
            }

            public FileToImageIconConverter(string filePath)
            {
                this.filePath = filePath;
            }
        }
        #endregion

    }
}
